Page MenuHomeFreeBSD

Add a section about Zstandard compression to the ZFS handbook
ClosedPublic

Authored by allanjude on Dec 22 2020, 3:27 AM.

Details

Summary

Sponsored by: The FreeBSD Foundation

Test Plan

Diff Detail

Repository
R9 FreeBSD doc repository
Lint
Automatic diff as part of commit; lint not applicable.
Unit
Automatic diff as part of commit; unit tests not applicable.

Event Timeline

ygy added a subscriber: ygy.

Looks good to me on the doc side.

This revision is now accepted and ready to land.Dec 23 2020, 3:06 PM
emaste added inline comments.
en_US.ISO8859-1/books/handbook/zfs/chapter.xml
2947–2948

I wonder if it would be clear to say no advantage to lower compression levels to avoid the double negative. Or something like "but read many times, Zstd allows the use of high compression levels without a performance penalty."

Remove double negative as suggested by emaste

This revision now requires review to proceed.Dec 23 2020, 3:25 PM
This revision is now accepted and ready to land.Dec 23 2020, 3:28 PM

I can't vouch for the technical accuracy of this, not having the required knowledge of ZFS and OpenZFS, but other than that and a few nits, this looks fine.

en_US.ISO8859-1/books/handbook/zfs/chapter.xml
2945

After the initial introduction of both "Zstandard" and its acronym "Zstd", I'd use one consistently, not a mix of both.

2955

Clarification: here and in the following paragraph, is it ZFS or OpenZFS?

2980

That paragraph doesn't state how to change the compression from the default.

allanjude added inline comments.
en_US.ISO8859-1/books/handbook/zfs/chapter.xml
2945

Done

2955

They are fairly synonymous, I think we'll have to do an entire pass over the handbook at some point

2980

That paragraph doesn't state how to change the compression from the default.

That is covered in the properties chapter, not sure if it makes sense to repeat it here. It might.

allanjude marked an inline comment as done.

Cleanup suggested by Pauamma

This revision now requires review to proceed.Dec 23 2020, 4:48 PM

Cool, a nice addition to the handbook covering the newer ZFS features. Thanks for the writeup!

This revision is now accepted and ready to land.Dec 23 2020, 4:50 PM

Do I remember wrong, or does Zstd also offer the option to adaptively compress at as high a level as possible while maintaining bandwidth, or is that only for zfs send|receive? If so, should that also be mentioned?

en_US.ISO8859-1/books/handbook/zfs/chapter.xml
2939–2940

Should this be "is the default as of FreeBSD 13-CURRENT and will be in 13.0-RELEASE"?

2957

s/cache/memory/

en_US.ISO8859-1/books/handbook/zfs/chapter.xml
2957

s/cache/memory/

Or better yet:
<acronym>RAM</acronym> instead of the word cache or the word memory.

emaste added inline comments.
en_US.ISO8859-1/books/handbook/zfs/chapter.xml
2948

mmm, reading it again, maybe we should mention without a "read" performance penalty?

Do I remember wrong, or does Zstd also offer the option to adaptively compress at as high a level as possible while maintaining bandwidth, or is that only for zfs send|receive? If so, should that also be mentioned?

That is the command line zstd tool, ZFS doesn't have anything like this (yet)

en_US.ISO8859-1/books/handbook/zfs/chapter.xml
2948

agreed

allanjude marked an inline comment as done.

Update with more feedback from emaste and debdrup

This revision now requires review to proceed.Dec 24 2020, 3:06 PM

I think you've addressed all the feedback and had approvals from everyone attached ;)

This revision is now accepted and ready to land.Dec 24 2020, 6:51 PM